<?php
# MINISKIN4 THEME MOTOR
# AND GENERAL SETTINGS

if (!defined('THEME_NAME')) {
    define('THEME_NAME','Miniskin4');
}
else {
    die;
}

if (!defined('THEME_VERSION')) {
    define('THEME_VERSION','0.1');
}
else {
    die;
}

# THESE COLORS ARE AVAILABLE
$theme_colors = array('blue','green','orange');

# THESE FONTS ARE AVAILABLE
$theme_fonts = array('arial','trebuchet-ms','verdana','times-new-roman','georgia');

# NEED TO GET SOME OPTIONS
require_once('setup_options.php');

if (!defined('SETTINGS_FILE')) {
    define('SETTINGS_FILE',strtolower(md5($DBname.THEME_NAME)).'.txt');
}
else {
    die;
}

# COMPRESSING HTML
function sanitize_output($buffer) {
    $search = array('/\>[^\S ]+/s','/[^\S ]+\</s','/(\s)+/s');
    $replace = array('>','<','\\1');
    $buffer = preg_replace($search,$replace,$buffer);
    return $buffer;
}

# DISABLING MODERN THEME TEMPLATES
if ((isset($startPageModern)) && (!empty($startPageModern)) && ($startPageModern !== FALSE)) {
    $startPageModern = FALSE;
}

# DISABLING SEPARATOR
if ((isset($l_sepr)) && (!empty($l_sepr))) {
    $l_sepr = NULL;
}

# CHECKING SITE NAME
if ((!isset($sitename)) or (empty($sitename))) {
    $sitename = THEME_NAME;
}

# IF USER IS AT THE ADMIN PANEL, LETS IMPORT JQUERY AND LIGHTBOX
if (strpos(str_replace('?','',$_SERVER['REQUEST_URI']),str_replace('?','',$bb_admin)) !== false) {
    $lightbox_for_admin = '<link href="templates/miniskin4/css/easybox.min.css" type="text/css" rel="stylesheet">
    <script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
    <script type="text/javascript" src="templates/miniskin4/js/easybox.min.js"></script>';
}
else {
    $lightbox_for_admin = NULL;
}

# LETS CREATE SETTINGS
if ((isset($DBname)) && (!empty($DBname))) {
    
    $actions = array('admin-'.strtolower(md5($DBname.THEME_NAME)));

    if ((file_exists('templates/miniskin4/'.SETTINGS_FILE)) && (is_readable('templates/miniskin4/'.SETTINGS_FILE)) && (is_writable('templates/miniskin4/'.SETTINGS_FILE))) {
        
        $settings_file = unserialize(file_get_contents('templates/miniskin4/'.SETTINGS_FILE,0,NULL,0));
        
        $last_modified = date ('Y-m-d H:i:s',filemtime('templates/miniskin4/'.SETTINGS_FILE));
        
        if ((!isset($last_modified)) or (empty($last_modified))) {
            $last_modified = 'Unknown';
        }
        
        if ((!empty($settings_file)) && (is_array($settings_file))) {        
            #print_r($settings_file);
            
            # CHECKING THE SETTINGS FILE CONTENTS
            if ($settings_file[0] === THEME_NAME) {
                foreach($settings_file as $setting) {
                    $theme_name = filter_var($settings_file[0],FILTER_SANITIZE_STRING);
                    $theme_generated = filter_var($settings_file[1],FILTER_SANITIZE_STRING);
                    $theme_color = filter_var($settings_file[2],FILTER_SANITIZE_STRING);
                    $theme_slogan = filter_var($settings_file[3],FILTER_SANITIZE_STRING);
                    $theme_version = filter_var($settings_file[4],FILTER_SANITIZE_STRING);
                    $theme_font = filter_var($settings_file[5],FILTER_SANITIZE_STRING);
                    $theme_gplus = filter_var($settings_file[6],FILTER_SANITIZE_URL);
                    $theme_introduction = filter_var($settings_file[7],FILTER_SANITIZE_STRING);
                    $theme_title = filter_var($settings_file[8],FILTER_SANITIZE_STRING);
                    $theme_favicon = filter_var($settings_file[9],FILTER_SANITIZE_URL);
                    $theme_css = filter_var($settings_file[10],FILTER_SANITIZE_STRING);
                    
                     
                     if ((!isset($theme_name)) or (empty($theme_name))) {
                         $theme_name = NULL;
                         $theme_admin_link = '<li id="special"><a href="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" 
                         rel="nofollow" class="lightbox" data-width="600">'.THEME_NAME.' ('.$theme_version.') Control Panel</a></li>';
                     }
                     else {
                         $theme_admin_link = '<li id="special"><a href="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" 
                         rel="nofollow" class="lightbox" data-width="600">'.THEME_NAME.' ('.$theme_version.') Control Panel</a></li>';
                     }

                     if ((!isset($theme_color)) or (empty($theme_color))) {
                         $theme_color = 'blue';
                     }
                     
                     $theme_color_tag = ' id="'.$theme_color.'"';

                     if ((!isset($theme_css)) or (empty($theme_css))) {
                         $theme_css = NULL;
                         $theme_custom_css_tag = NULL;
                     }
                     else {
                         $theme_custom_css_tag = '<style type="text/css">'.$theme_css.'</style>';
                     }

                     if ((!isset($theme_title)) or (empty($theme_title))) {
                         $theme_title = THEME_NAME;
                     }

                     if ((!isset($theme_favicon)) or (empty($theme_favicon))) {
                         $theme_favicon = NULL;
                         $theme_favicon_tag = '<link rel="icon" type="image/ico" href="/templates/miniskin4/favicon.ico">';
                     }
                    else {
                        $theme_favicon_tag = '<link rel="icon" type="image/ico" href="'.$theme_favicon.'">';
                    }

                     if ((!isset($theme_font)) or (empty($theme_font))) {
                         $theme_font = 'arial';
                         $theme_font_tag = NULL;
                     }
                     elseif ($theme_font === 'trebuchet-ms') {
                         $theme_font_tag = '<style type="text/css">* { font-family: "Trebuchet MS", Helvetica, sans-serif !important; }</style>';
                     }
                     elseif ($theme_font === 'verdana') {
                         $theme_font_tag = '<style type="text/css">* { font-family: Verdana, Geneva, sans-serif !important; }</style>';
                     }
                     elseif ($theme_font === 'times-new-roman') {
                         $theme_font_tag = '<style type="text/css">* { font-family: "Times New Roman", Times, serif !important; }</style>';
                     }
                     elseif ($theme_font === 'georgia') {
                         $theme_font_tag = '<style type="text/css">* { font-family: Georgia, serif !important; }</style>';
                     }

                     if ((!isset($theme_gplus)) or (empty($theme_gplus))) {
                         $theme_gplus = NULL;
                         $theme_gplus_tag = NULL;
                     }
                     else {
                         $theme_gplus_tag = '<link href="'.$theme_gplus.'" rel="publisher">';
                     }

                     if ((!isset($theme_introduction)) or (empty($theme_introduction))) {
                         $theme_introduction = NULL;
                         $theme_introduction_tag = NULL;
                     }
                     else {
                         $theme_introduction_tag = '<p id="welcome">'.$theme_introduction.'</p>';
                     }

                     if ((!isset($theme_slogan)) or (empty($theme_slogan))) {
                         $theme_slogan_html = NULL;
                         $theme_slogan = NULL;
                     }
                     else {
                         $theme_slogan_html = '<p id="slogan">'.$theme_slogan.'</p>';
                     }
                     
                }
                
            }

        }
        else {
            die(THEME_NAME.' configuration file is corrupt.');
        }
        
    }
    else {
        # IN THIS PHASE WE HAVE NO SETTINGS FILE, SO LETS START WITH FACTORY SETTINGS:
        # 0 = THEME NAME
        # 1 = DATE WHEN CREATED
        # 2 = DEFAULT COLOR SCHEME
        # 3 = THEME SLOGAN
        # 4 = THEME SYSTEM VERSION
        # 5 = THEME FONT
        # 6 = AUTHOR GOOGLE+ URL
        # 7 = FORUM INTRODUCTION/WELCOME TEXT
        # 8 = FORUM TITLE
        # 9 = FAVICON URL
        # 10 = CUSTOM CSS
        $factory_settings = serialize(array(THEME_NAME,date('Y-m-d'),'blue','A customizable HTML5 theme for miniBB.',THEME_VERSION,'arial','','',THEME_NAME,'',''));

        # WRITING DATA TO THE FILE
        $settings_file = file_put_contents('templates/miniskin4/'.SETTINGS_FILE,$factory_settings,LOCK_EX) or die('<p class="warning">Unable to launch '.THEME_NAME.'.</p>');
    }

    # LETS SEE IF URL IS SPECIAL
    if ((isset($_GET['action'])) && (!empty($_GET['action'])) && (in_array($_GET['action'],$actions))) {
        
        # FETCHING ADMIN'S COOKIE INFO
        $user_cookie = explode('|',$_COOKIE[$cookiename]);

        # LETS CHECK IF USER IS LOGGED IN
        if ((!isset($_COOKIE[$cookiename])) or (empty($_COOKIE[$cookiename])) or ($user_cookie[0] !== $admin_usr) or ($user_cookie[1] !== md5($admin_pwd))) {
            header('location:'.$main_url);
            die;
        }
        
        unset($user_cookie);

        $action = strtolower(filter_var($_GET['action'],FILTER_SANITIZE_STRING));
        if ($action === 'admin-'.strtolower(md5($DBname.THEME_NAME))) {

            # IF FORM IS SUBMITTED IT MEANS DATA
            # NEEDS TO BE VALIDATED AND SAVED
            if ((isset($_POST['save'])) && (empty($_POST['save']))) {
                
                # THIS IS FOR ERROR MESSAGES ETC.
                $notifications = array();
                
                # THIS IS THE FILE WE SAVE DATA TO
                $saved_settings = unserialize(file_get_contents('templates/miniskin4/'.SETTINGS_FILE,0,NULL,0));
                
                # TITLE
                if (isset($_POST['title'])) {
                    $theme_title = filter_var($_POST['title'],FILTER_SANITIZE_STRING);
                    # SLOGAN IS CHANGED AND SAVED
                    if ((strlen($theme_title <= 255)) && ($saved_settings[8] !== $theme_title)) {
                        $saved_settings[8] = $theme_title;
                        file_put_contents('templates/miniskin4/'.SETTINGS_FILE,serialize($saved_settings));
                        array_push($notifications,'Title was saved.');
                    }
                    elseif ((strlen($theme_title <= 255)) && ($saved_settings[8] == $theme_title)) {
                        array_push($notifications,'Title is the same as previous one.');
                    }
                    else {
                        array_push($notifications,'Title was not saved. Please keep it at maximum 255 characters.');
                    }
                }

                # SLOGAN
                if (isset($_POST['slogan'])) {
                    $theme_slogan = filter_var($_POST['slogan'],FILTER_SANITIZE_STRING);
                    # SLOGAN IS CHANGED AND SAVED
                    if ((strlen($theme_slogan <= 255)) && ($saved_settings[3] !== $theme_slogan)) {
                        $saved_settings[3] = $theme_slogan;
                        file_put_contents('templates/miniskin4/'.SETTINGS_FILE,serialize($saved_settings));
                        array_push($notifications,'Slogan was saved.');
                    }
                    elseif ((strlen($theme_slogan <= 255)) && ($saved_settings[3] == $theme_slogan)) {
                        array_push($notifications,'Slogan is the same as previous one.');
                    }
                    else {
                        array_push($notifications,'Slogan was not saved. Please keep it at maximum 255 characters.');
                    }
                }

                # GOOGLE+
                if (isset($_POST['gplus'])) {
                    $theme_gplus = filter_var($_POST['gplus'],FILTER_SANITIZE_URL);
                    # SLOGAN IS CHANGED AND SAVED
                    if ((strlen($theme_gplus <= 255)) && ($saved_settings[6] !== $theme_gplus)) {
                        $saved_settings[6] = $theme_gplus;
                        file_put_contents('templates/miniskin4/'.SETTINGS_FILE,serialize($saved_settings));
                        array_push($notifications,'Google+ URL was saved.');
                    }
                    elseif ((strlen($theme_gplus <= 255)) && ($saved_settings[6] == $theme_gplus)) {
                        array_push($notifications,'Google+ URL is the same as previous one.');
                    }
                    else {
                        array_push($notifications,'Google+ URL was not saved. Please keep it at maximum 255 characters and make sure it\'s a valid URL address.');
                    }
                }

                # INTRODUCTION/WELCOME
                if (isset($_POST['introduction'])) {
                    $theme_introduction = filter_var($_POST['introduction'],FILTER_SANITIZE_STRING);
                    # SLOGAN IS CHANGED AND SAVED
                    if ((strlen($theme_introduction <= 500)) && ($saved_settings[7] !== $theme_introduction)) {
                        $saved_settings[7] = $theme_introduction;
                        file_put_contents('templates/miniskin4/'.SETTINGS_FILE,serialize($saved_settings));
                        array_push($notifications,'Introduction/welcome text was saved.');
                    }
                    elseif ((strlen($theme_introduction <= 500)) && ($saved_settings[7] == $theme_introduction)) {
                        array_push($notifications,'Introduction/welcome text is the same as previous one.');
                    }
                    else {
                        array_push($notifications,'Introduction/welcome text was not saved. Please keep it at maximum 500 characters.');
                    }
                }

                # COLOR SCHEME
                if (isset($_POST['color'])) {
                    $theme_color = filter_var($_POST['color'],FILTER_SANITIZE_STRING);
                    # SLOGAN IS CHANGED AND SAVED
                    if (($saved_settings[2] !== $theme_color) && (in_array($theme_color,$theme_colors))) {
                        $saved_settings[2] = $theme_color;
                        file_put_contents('templates/miniskin4/'.SETTINGS_FILE,serialize($saved_settings));
                        array_push($notifications,'Theme color was saved.');
                    }
                    elseif ($saved_settings[2] == $theme_color) {
                        array_push($notifications,'Theme color is the same as previous one.');
                    }
                    else {
                        array_push($notifications,'An error occurred when trying to save theme color.');
                    }
                }

                # FONT
                if (isset($_POST['font'])) {
                    $theme_font = filter_var($_POST['font'],FILTER_SANITIZE_STRING);
                    # SLOGAN IS CHANGED AND SAVED
                    if (($saved_settings[5] !== $theme_font) && (in_array($theme_font,$theme_fonts))) {
                        $saved_settings[5] = $theme_font;
                        file_put_contents('templates/miniskin4/'.SETTINGS_FILE,serialize($saved_settings));
                        array_push($notifications,'Theme font was saved.');
                    }
                    elseif ($saved_settings[5] == $theme_font) {
                        array_push($notifications,'Theme font is the same as previous one.');
                    }
                    else {
                        array_push($notifications,'An error occurred when trying to save theme font.');
                    }
                }

                # FAVICON
                if (isset($_POST['favicon'])) {
                    $theme_favicon = filter_var($_POST['favicon'],FILTER_SANITIZE_URL);
                    # SLOGAN IS CHANGED AND SAVED
                    if ((strlen($theme_favicon <= 255)) && ($saved_settings[9] !== $theme_favicon)) {
                        $saved_settings[9] = $theme_favicon;
                        file_put_contents('templates/miniskin4/'.SETTINGS_FILE,serialize($saved_settings));
                        array_push($notifications,'Favicon URL was saved.');
                    }
                    elseif ((strlen($theme_favicon <= 255)) && ($saved_settings[9] == $theme_favicon)) {
                        array_push($notifications,'Favicon URL is the same as previous one.');
                    }
                    else {
                        array_push($notifications,'Favicon URL was not saved. Please keep it at maximum 255 characters and make sure it\'s a valid URL address.');
                    }
                }

                # CUSTOM CSS
                if (isset($_POST['css'])) {
                    $theme_css = filter_var($_POST['css'],FILTER_SANITIZE_STRING);
                    # SLOGAN IS CHANGED AND SAVED
                    if ((strlen($theme_css <= 500)) && ($saved_settings[10] !== $theme_css)) {
                        $saved_settings[10] = $theme_css;
                        file_put_contents('templates/miniskin4/'.SETTINGS_FILE,serialize($saved_settings));
                        array_push($notifications,'Custom CSS was saved.');
                    }
                    elseif ((strlen($theme_css <= 500)) && ($saved_settings[10] == $theme_css)) {
                        array_push($notifications,'Custom CSS is the same as previous one.');
                    }
                    else {
                        array_push($notifications,'Custom CSS was not saved. Please keep it at maximum 500 characters.');
                    }
                }                
                
            }
            else {
                $notifications = NULL;
            }
            
            ob_start("sanitize_output");

            # THIS IS THE HTML FOR CONTROL PANEL
            echo '<!doctype html><html><head><title>'.THEME_NAME.' ('.$theme_version.') Control Panel</title><link href="'.$main_url.'/templates/miniskin4/css/layout.css" type="text/css" rel="stylesheet" media="all">
            <meta name="robots" content="noindex,nofollow,noarchive"></head><body id="admin">
            <h1> '.THEME_NAME.' ('.$theme_version.') <span>Theme\'s system initialized '.$theme_generated.'<br />Last modified '.$last_modified.'</span></h1>';

            # LETS SHOW POSSIBLE ERROR MESSAGES
            if ($notifications !== NULL) {
                echo '<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
                <script type="text/javascript">$(document).ready(function(){$("#notifications").delay(3200).fadeOut(300);});</script>
                <ul id="notifications">';
                foreach($notifications as $notification) {
                    echo '<li>'.$notification.'</li>';
                 }
                echo '</ul>';
            }

            echo '<form action="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" method="post">
            <fieldset>
            <legend><strong>Misc.</strong> Forum title</legend>
                <ul>
                <li><label for="forum-slogan">Title at the header:</label><input id="forum-title" type="text" name="title" placeholder="Max. 255 characters" size="20" maxlength="255" value="'.$theme_title.'"></li>
                <li><button type="submit" name="save">&rarr;</button></li>
                </ul>
            </fieldset>
            </form>
            <form action="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" method="post">
            <fieldset>
            <legend><strong>Misc.</strong> Forum slogan</legend>
                <ul>
                <li><label for="forum-slogan">Slogan under title:</label><input id="forum-slogan" type="text" name="slogan" placeholder="Max. 255 characters" size="20" maxlength="255" value="'.$theme_slogan.'"></li>
                <li><button type="submit" name="save">&rarr;</button></li>
                </ul>
            </fieldset>
            </form>            
            <form action="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" method="post">
            <fieldset>
            <legend><strong>Some</strong> Google+ URL</legend>
                <ul>
                <li><label for="forum-gplus">Google+ URL:</label><input id="forum-gplus" type="text" name="gplus" placeholder="Max. 255 characters" size="20" maxlength="255" value="'.$theme_gplus.'"></li>
                <li><button type="submit" name="save">&rarr;</button></li>
                </ul>
            </fieldset>
            </form>
            <form action="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" method="post">
            <fieldset>
            <legend><strong>SEO</strong> Forum introduction / welcome text</legend>
                <ul>
                <li><label for="forum-introduction">Introduction/welcome text:</label><textarea id="forum-introduction" name="introduction" cols="30" rows="10" placeholder="Max. 500 characters" maxlength="500">'.$theme_introduction.'</textarea></li>
                <li><button type="submit" name="save">&rarr;</button></li>
                </ul>
            </fieldset>
            </form>
            <form action="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" method="post">
            <fieldset>
            <legend><strong>UI</strong> Favicon URL</legend>
                <ul>
                <li><label for="forum-favicon">Favicon URL:</label><input id="forum-favicon" type="text" name="favicon" placeholder="Max. 255 characters" size="20" maxlength="255" value="'.$theme_favicon.'"></li>
                <li><button type="submit" name="save">&rarr;</button></li>
                </ul>
            </fieldset>
            </form>
            <form action="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" method="post">
            <fieldset>
            <legend><strong>UI</strong> Theme color</legend>
                <ul>
                <li><label for="theme-color">Select scheme:</label>';
                # THIS NEEDS TO BE DONE LIKE THIS
                ?>
                <select id="theme-color" name="color">
                    <option value="blue"<?php if ($theme_color === 'blue') { echo ' selected="selected"'; } ?>>Blue (default)</option>
                    <option value="green"<?php if ($theme_color === 'green') { echo ' selected="selected"'; } ?>>Green</option>
                    <option value="orange"<?php if ($theme_color === 'orange') { echo ' selected="selected"'; } ?>>Orange</option>
                </select></li>
                <?php echo'<li><button type="submit" name="save">&rarr;</button></li>
                </ul>
            </fieldset>
            </form>
            <form action="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" method="post">
            <fieldset>
            <legend><strong>UI</strong> Theme font</legend>
                <ul>
                <li><label for="theme-font">Select font:</label>';
                # THIS NEEDS TO BE DONE LIKE THIS
                ?>
                <select id="theme-font" name="font">
                    <option value="arial"<?php if ($theme_font === 'arial') { echo ' selected="selected"'; } ?>>Arial (default)</option>
                    <option value="trebuchet-ms"<?php if ($theme_font === 'trebuchet-ms') { echo ' selected="selected"'; } ?>>Trebuchet MS</option>
                    <option value="verdana"<?php if ($theme_font === 'verdana') { echo ' selected="selected"'; } ?>>Verdana</option>
                    <option value="times-new-roman"<?php if ($theme_font === 'times-new-roman') { echo ' selected="selected"'; } ?>>Times New Roman</option>
                    <option value="georgia"<?php if ($theme_font === 'georgia') { echo ' selected="selected"'; } ?>>Georgia</option>
                    </select></li>
                <?php echo '<li><button type="submit" name="save">&rarr;</button></li>
                </ul>
            </fieldset>
            </form>
            <form action="'.$main_url.'/miniskin4.php?action=admin-'.strtolower(md5($DBname.THEME_NAME)).'" method="post">
            <fieldset>
            <legend><strong>UI</strong> Custom CSS</legend>
                <ul>
                <li><label for="forum-css">Your CSS for theme:</label><textarea id="forum-css" name="css" cols="30" rows="10" placeholder="Max. 500 characters" maxlength="500">'.$theme_css.'</textarea></li>
                <li><button type="submit" name="save">&rarr;</button></li>
                </ul>
            </fieldset>
            </form>
            </body></html>';
        }
        else {
            die;
        }
}

}
?>